﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;

namespace HyperCube.Models
{
    public class SmartContract
    {
        public int ID;
        public string Code;
        public string ByteCode;
        public string Name = "";
        public string Address = "";

        public static SmartContract Find(string name)
        {
            var bc = Blockchain.GetMain();
            if (bc != null)
            {
                var contracts = bc.contractNames;
                if (contracts.ContainsKey(name))
                {
                    return contracts[name];
                }
            }
            return null;
        }

        public SmartContract()
        { }

        public Task Run(string weiValue = "0x0")
        {
            return null;
        }

        public SmartContract(int id, string name, string code, string bytecode)
        {
            ID = id;
            Name = name;
            Code = code;
            ByteCode = bytecode;
        }

        public async Task<long> AddFunction(string name_with_args, string compiled_header)
        {
            return MySQLConnector.Instance().SQLInsert($"insert into functions (name_with_args, contract_id, compiled_header) values ('{name_with_args}',{ID},'{compiled_header}')");
        }
    }

    public class VerifyContract : SmartContract
    {
        public async Task Run(ArticleModel newArticle, string weiValue = "0x0")
        {
            var uuid = await newArticle.GetInitiatorUUID();
            var initiator = AccountModel.Find(uuid);
            if (initiator != null)
            {
                Console.WriteLine($"VerifyContract Run {initiator.Name} {newArticle}");
                var res = Blockchain.GetMain().RunContractWrite(Address, "0x11111111");
            }
        }
    }
}